Bug 869797 - Review Request: gap-Browse - GAP browser for 2-dimensional arrays of data
Review Request: gap-Browse - GAP browser for 2-dimensional arrays of data
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Paulo Andrade
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-24 16:16 EDT by Jerry James
Modified: 2013-02-01 12:18 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-01 12:18:13 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
paulo.cesar.pereira.de.andrade: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jerry James 2012-10-24 16:16:22 EDT
Spec URL: http://jjames.fedorapeople.org/gap-Browse/gap-Browse.spec
SRPM URL: http://jjames.fedorapeople.org/gap-Browse/gap-Browse-1.8.2-1.fc19.src.rpm
Description: This package gives GAP an interface to ncurses, with functions built on top to interactively browse 2-dimensional tables of data.  Some sample applications of this functionality are also included.
Fedora Account System Username: jjames
Comment 1 Paulo Andrade 2013-01-15 11:11:33 EST
I will review this package.
Jerry, if you have another small/simple package, or for free :-) please consider #894610
Comment 2 Paulo Andrade 2013-01-15 21:04:27 EST
Below I add a suggested patch to not provide the private .so and to use
standard permission flags in the .so.

Not sure how and if a %check could be added. Maybe somehow parse the
output of something like:
echo 'Test("tst/test.tst");' | gap -l "%{_gap_dir};%{buildroot}%{_gap_dir}"
but that should generate some funny output in build.log
BTW, after a lot of flashing and colors in my xterm the final output
of the above is:

$ echo 'Test("tst/test.tst");' | gap -l "/usr/lib/gap;/home/pcpa/rpmbuild/BUILDROOT/gap-Browse-1.8.2-1.fc19.x86_64/usr/lib/gap" 
 ┌───────┐   GAP, Version 4.5.7 of 14-Dec-2012 (free software, GPL)
 │  GAP  │   http://www.gap-system.org
 └───────┘   Architecture: x86_64-redhat-linux-gnu-gcc-default64
 Libs used:  gmp, readline
 Loading the library and packages ...
 Components: trans 1.0, prim 2.1, small* 1.0, id* 1.0
 Packages:   Browse 1.8.2, CTblLib 1.2.1, GAPDoc 1.5.1, IO 4.2, TomLib 1.2.2
             
 Try '?help' for help. See also  '?copyright' and  '?authors'
########> Diff in tst/test.tst, line 252:
# Input is:
if fail in tworeps then
     Print( "no access to the Web ATLAS\n" );
   else
     Print( List( tworeps, x -> x.identifier[1] ), "\n" );
   fi;
# Expected output:
[ "A5", "A6" ]
# But found:
no access to the Web ATLAS
########
Browse/tst/test.tst
GAP4stones: 0
false
gap> $ 



---%<---

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Permissions on files are set properly.
     Note: See rpmlint output
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions


===== MUST items =====

C/C++:
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[!]: Permissions on files are set properly.
     Note: See rpmlint output
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/pcpa/869797-gap-Browse/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 61440 bytes in 3 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[ ]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (Browse-1.8.2.tar.bz2)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: gap-Browse-debuginfo-1.8.2-1.fc19.x86_64.rpm
          gap-Browse-1.8.2-1.fc19.x86_64.rpm
          gap-Browse-1.8.2-1.fc19.src.rpm
gap-Browse.x86_64: W: spelling-error %description -l en_US unhide -> Brunhilde
gap-Browse.x86_64: W: spelling-error %description -l en_US ncurses -> nurses, curses, n curses
gap-Browse.x86_64: W: spelling-error %description -l en_US BrowseGeneric -> Browse Generic, Browse-generic, Generically
gap-Browse.x86_64: E: non-standard-executable-perm /usr/lib/gap/pkg/Browse/bin/x86_64-redhat-linux-gnu-gcc-default64/ncurses.so 0775L
gap-Browse.src: W: spelling-error %description -l en_US unhide -> Brunhilde
gap-Browse.src: W: spelling-error %description -l en_US ncurses -> nurses, curses, n curses
gap-Browse.src: W: spelling-error %description -l en_US BrowseGeneric -> Browse Generic, Browse-generic, Generically
gap-Browse.src:54: W: configure-without-libdir-spec
3 packages and 0 specfiles checked; 1 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint gap-Browse-debuginfo gap-Browse
gap-Browse.x86_64: W: spelling-error %description -l en_US unhide -> Brunhilde
gap-Browse.x86_64: W: spelling-error %description -l en_US ncurses -> nurses, curses, n curses
gap-Browse.x86_64: W: spelling-error %description -l en_US BrowseGeneric -> Browse Generic, Browse-generic, Generically
gap-Browse.x86_64: E: non-standard-executable-perm /usr/lib/gap/pkg/Browse/bin/x86_64-redhat-linux-gnu-gcc-default64/ncurses.so 0775L
2 packages and 0 specfiles checked; 1 errors, 3 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/pcpa/869797-gap-Browse/srpm/gap-Browse.spec	2013-01-15 22:43:53.922921818 -0200
+++ /home/pcpa/869797-gap-Browse/srpm-unpacked/gap-Browse.spec	2013-01-15 22:45:06.278919626 -0200
@@ -11,5 +11,6 @@
 BuildRequires:  ncurses-devel
 
-Requires:       gap-character-tables
+Requires:       gap-core
+Requires:       GAPDoc
 
 Provides:       gap-pkg-Browse = %{version}-%{release}


Requires
--------
gap-Browse-debuginfo-1.8.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    

gap-Browse-1.8.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /bin/sh  
    GAPDoc  
    gap-core  
    libc.so.6()(64bit)  
    libncurses.so.5()(64bit)  
    libpanel.so.5()(64bit)  
    libtinfo.so.5()(64bit)  
    rtld(GNU_HASH)  



Provides
--------
gap-Browse-debuginfo-1.8.2-1.fc19.x86_64.rpm:
    
    gap-Browse-debuginfo = 1.8.2-1.fc19
    gap-Browse-debuginfo(x86-64) = 1.8.2-1.fc19

gap-Browse-1.8.2-1.fc19.x86_64.rpm:
    
    gap-Browse = 1.8.2-1.fc19
    gap-Browse(x86-64) = 1.8.2-1.fc19
    gap-pkg-Browse = 1.8.2-1.fc19
    ncurses.so()(64bit)  



Unversioned so-files
--------------------
gap-Browse-1.8.2-1.fc19.x86_64.rpm: /usr/lib/gap/pkg/Browse/bin/x86_64-redhat-linux-gnu-gcc-default64/ncurses.so

MD5-sum check
-------------
http://www.math.rwth-aachen.de/~Browse/Browse-1.8.2.tar.bz2 :
  CHECKSUM(SHA256) this package     : f8d052ef315f2060fde426795bffe21706fe3c7ca543ecdd0cbae9002252fa60
  CHECKSUM(SHA256) upstream package : f8d052ef315f2060fde426795bffe21706fe3c7ca543ecdd0cbae9002252fa60


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 869797 -m fedora-rawhide-x86_64
---%<---

Using the spec from the srpm, I suggest this small diff:
$ diff -u SPECS/gap-Browse.spec{.orig,}
--- SPECS/gap-Browse.spec.orig  2013-01-15 23:10:43.959116635 -0200
+++ SPECS/gap-Browse.spec       2013-01-15 23:49:32.358205797 -0200
@@ -1,3 +1,5 @@
+%global __provides_exclude_from        %{_gap_dir}/.*/ncurses\\.so
+
 Name:           gap-Browse
 Version:        1.8.2
 Release:        1%{?dist}
@@ -66,6 +68,10 @@
 rm -f %{buildroot}%{_gap_dir}/pkg/Browse/{CHANGES,README}
 rm -fr %{buildroot}%{_gap_dir}/pkg/Browse/src
 
+# Ensure proper permissions
+source %{_gap_dir}/sysinfo.gap
+chmod 755 %{buildroot}%{_gap_dir}/pkg/Browse/bin/$GAParch/ncurses.so
+
 %files
 %doc CHANGES README doc/GPL
 %{_gap_dir}/pkg/Browse/
Comment 3 Jerry James 2013-01-18 16:56:17 EST
Thanks for the spec file patch.  I mostly used it, with a couple of tweaks.  I have experimented with various ways of doing testing for the last couple of days, and haven't really found anything satisfactory.  I put a note at the top of the spec file to remind myself to test it manually before each release.  New package:

Spec URL: http://jjames.fedorapeople.org/gap-Browse/gap-Browse.spec
SRPM URL: http://jjames.fedorapeople.org/gap-Browse/gap-Browse-1.8.2-2.fc19.src.rpm
Comment 4 Paulo Andrade 2013-01-19 07:56:49 EST
I do not see any remaining issues.
I only suggest something like:

-# gap -l "%{_gapdir};%{buildroot}%{_gapdir}" <<< 'Test("tst/test.tst");'
+# gap -l "${_gapdir};${buildroot}${_gapdir}" <<< 'Test("tst/test.tst");'

or variant for the sake of silencing a bit rpmlint before
committing to git. But that is optional, as there are already
several spelling warnings that must be ignored.

I consider the package APPROVED.
Comment 5 Jerry James 2013-01-19 14:42:58 EST
Thanks, Paulo.  I will make that change before committing to git.

New Package SCM Request
=======================
Package Name: gap-Browse
Short Description: GAP browser for 2-dimensional arrays of data
Owners: jjames
Branches: f18
InitialCC:
Comment 6 Gwyn Ciesla 2013-01-22 09:07:40 EST
Git done (by process-git-requests).
Comment 7 Fedora Update System 2013-01-22 12:58:46 EST
gap-Browse-1.8.2-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/gap-Browse-1.8.2-2.fc18
Comment 8 Fedora Update System 2013-01-23 11:10:09 EST
gap-Browse-1.8.2-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 9 Fedora Update System 2013-02-01 12:18:14 EST
gap-Browse-1.8.2-2.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.